2 ### quick-install-emacs --- do a halfway-decent job of installing emacs quickly
4 ## Copyright (C) 2001-2011 Free Software Foundation, Inc.
6 ## Author: Miles Bader <miles@gnu.org>
8 ## This file is part of GNU Emacs.
10 ## GNU Emacs is free software: you can redistribute it and/or modify
11 ## it under the terms of the GNU General Public License as published by
12 ## the Free Software Foundation, either version 3 of the License, or
13 ## (at your option) any later version.
15 ## GNU Emacs is distributed in the hope that it will be useful,
16 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
17 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18 ## GNU General Public License for more details.
20 ## You should have received a copy of the GNU General Public License
21 ## along with GNU Emacs. If not, see <http://www.gnu.org/licenses/>.
26 ## This script is mainly intended for emacs maintainer or pretesters who
27 ## install emacs very often. See the --help output for more details.
30 PUBLIC_LIBSRC_BINARIES
='emacsclient etags ctags ebrowse'
31 PUBLIC_LIBSRC_SCRIPTS
='grep-changelog rcs-checkin'
33 AVOID
="CVS -DIC README COPYING ChangeLog ~ [.]orig$ [.]rej$ Makefile$ Makefile.in$ makefile$ makefile.w32-in$ stamp-subdir [.]cvsignore [.]arch-ids [{]arch[}] [.][cho]$ make-docfile testfile test-distrib"
35 # Prune old binaries lying around in the source tree
37 # Re-install files even if they already exist
39 # Command verbose flag
44 # Install commands (if the user specifies the `--verbose' option, it is
45 # passed to these commands, so that feature only works if these commands
52 # Used to execute commands once once we create them
57 # avoid non-standard command output from non-C locales
58 unset LANG LC_ALL LC_MESSAGES
61 USAGE
="Usage: $me [OPTION...] BUILD_TREE [PREFIX]"
62 TRY
="Try "\
`"$me --help' for more information."
64 # Parse command-line options
84 -n, --dry-run print installation commands instead of
87 -f, --force install even files that haven't changed
88 -v, --verbose print messages describing what is done
90 -p, --prune prune old generated files
91 -P, --no-prune don't prune old generated files (default)
92 --prune-only prune old generated files, but don't install
94 --help display this help and exit
95 --version output version information and exit
97 $me install emacs \`incrementally
,' that is, it will
98 install only those files that have changed since the last time it was
99 invoked, and remove any obsolete files from the installation
100 directories. It also uses hard-links into the source and build trees to
101 do the install, so it uses much less space than the default Makefile
102 install target; however, this also means that $me can
103 not install onto a disk partition other than the one on which the source
104 and build directories reside.
106 Optionally, $me can also remove old versions of
107 automatically generated files that are version-specific (such as the
108 versioned emacs executables in the \`src' directory
, and the DOC-
* files
109 in the \
`etc' directory). The latter action is called \`pruning
,' and
110 can be enabled using the \`-p' or \
`--prune' options.
118 Written by Miles Bader <miles@gnu.org>
123 # split concatenated single-letter options apart
125 set -- `echo $FIRST |
sed 's/-\(.\)\(.*\)/-\1 -\2/'` "$@"
128 echo 1>&2 "$me: unrecognized option "\`"$1'"
137 LINK_CMD
="$LINK $VERBOSE"
138 REMOVE_CMD
="$REMOVE $VERBOSE"
142 2) BUILD
="$1"; prefix
="$2";;
150 if test ! -d "$BUILD"; then
151 echo 1>&2 "$me: $BUILD: Build tree not found"
153 elif test ! -r "$BUILD/config.status"; then
154 echo 1>&2 "$me: $BUILD: Not a proper build tree, config.status not found"
158 CONFIG_STATUS
="$BUILD/config.status"
161 { sed -n "s/^S[[]\"$1\"[]]=\"\([^\"]*\)\"/\1/p" $CONFIG_STATUS |
sed q |
grep ''; } ||
162 { sed -n "s/^s\(.\)@$1@\1\(|#_!!_#|\)*\(.*\)\1.*$/\3/p" $CONFIG_STATUS |
sed q |
grep ''; } ||
164 echo 1>&2 "$me: $1: Configuration variable not found in $CONFIG_STATUS"
169 test x
"$SRC" = x
&& { SRC
="`get_config_var srcdir`" ||
exit 4 ; }
170 test x
"$prefix" = x
&& { prefix
="`get_config_var prefix`" ||
exit 4 ; }
171 test x
"$ARCH" = x
&& { ARCH
="`get_config_var host`" ||
exit 4 ; }
174 sed -n 's/^AC_INIT(emacs,[ ]*\([^ )]*\).*/\1/p' <$SRC/configure.in
176 test -n "$VERSION" ||
{ echo >&2 "$me: no version in configure.in"; exit 4; }
178 DST_SHARE
="$prefix/share/emacs/$VERSION"
179 DST_BIN
="$prefix/bin"
180 DST_LIBEXEC
="$prefix/libexec/emacs/$VERSION/$ARCH"
182 # There are various common places for the info dir to be, so try to
183 # use whatever's already there, defaulting to (and preferring)
187 for D
in "$prefix/share/info" "$prefix/info"; do
188 if test -d "$D"; then
193 DST_INFO
=${DST_INFO:-"$prefix/share/info"}
197 if ! test -d "$1"; then
198 $MKDIR $VERBOSE "$1" 2>&1 |
sed "s/^mkdir:/$me:/" 1>&2
202 maybe_mkdir
"$DST_BIN"
203 maybe_mkdir
"$DST_SHARE"
204 maybe_mkdir
"$DST_SHARE/site-lisp"
205 maybe_mkdir
"$DST_LIBEXEC"
206 maybe_mkdir
"$DST_INFO"
208 ( # start of command-generating sub-shell
211 if test x
"$PRUNE" != xno
; then
212 for D
in `ls -1t $BUILD/etc/DOC-* | sed 1d`; do
216 for D
in `ls -1t $BUILD/src/emacs-$VERSION.* | sed 1d`; do
222 test x
"$PRUNE" = xonly
&& exit 0
226 if test "$FORCE" = yes ||
! cmp -s $1 $2; then
231 maybe_emit_copy
$BUILD/src
/emacs
$DST_BIN/emacs
232 maybe_emit_copy
$BUILD/src
/emacs
$DST_BIN/emacs-
$VERSION
234 for F
in $PUBLIC_LIBSRC_BINARIES; do
235 maybe_emit_copy
$BUILD/lib-src
/$F $DST_BIN/$F
237 for F
in $PUBLIC_LIBSRC_SCRIPTS; do
238 maybe_emit_copy
$SRC/lib-src
/$F $DST_BIN/$F
241 if test x
"$SRC" = x
"$BUILD"; then
247 for SUBDIR
in lisp leim etc lib-src info
; do
251 AVOID_PAT
="`echo "($AVOID)" | tr ' ' '|'`"
253 # Set subdir-specific values
256 DST
="$DST_SHARE/$SUBDIR"
259 DST
="$DST_SHARE/$SUBDIR"
260 # COPYING is in the avoid list, but there should be a copy of it in
261 # the install etc dir, so make that here.
262 FORCED
="$DST/COPYING"
266 AVOID_PAT
="`echo "($AVOID ($PUBLIC_LIBSRC_BINARIES $PUBLIC_LIBSRC_SCRIPTS)\$
)" | tr ' ' '|'`"
275 if [ -d $PFX/$SUBDIR ]; then
276 for DIR
in `(cd $PFX/$SUBDIR; find . -type d -print | sed 's@^./@@')`; do
277 if [ -d $DST/$DIR ]; then
278 echo Directory
$DST/$DIR exists
280 echo Directory
$DST/$DIR non-existent
281 if [ "`echo $DIR | egrep -v "$AVOID_PAT"`" ]; then
282 maybe_mkdir
$DST/$DIR
286 diff -sqr $PFX/$SUBDIR $DST
290 src_pat = "^'"$SRC"'/'"$SUBDIR"'/"
291 build_pat = "^'"$BUILD"'/'"$SUBDIR"'/"
292 dst_pat = "^'"$DST"'/"
293 dst_pfx = "'"$DST"'/"
294 avoid_pat = "'"$AVOID_PAT"'"
295 force = ("'"$FORCE"'" == "yes")
296 shared = ("'"$SHARED"'" == "yes")
297 init_bool_array(pruned, "'"$PRUNED"'")
298 init_bool_array(forced, "'"$FORCED"'")
300 function init_bool_array(array, string, a,k)
306 function install(src, dst)
308 if (! (src in pruned)) {
314 function update(src, dst, copy)
326 function uninstall(dst)
332 if ($2 ~ avoid_pat) {
340 if ($4 ~ avoid_pat && !($4 in forced))
342 else if ($NF == "identical")
343 update($2, $4, force)
357 if (subdir ~ src_pat)
358 sub (src_pat, "", subdir)
360 sub (build_pat, "", subdir)
362 dst = dst_pfx subdir $4
363 if (! (dst ~ avoid_pat))
370 print "'"$REMOVE_CMD"' " f
372 print "'"$LINK_CMD"' " f " " cp[f]